package com.tencent.cloud.dtf.demo.inventory.dao;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementSetter;
import org.springframework.stereotype.Component;

import com.tencent.cloud.dtf.demo.inventory.Inventory;

@Component
public class InventoryDao {

    private static final Logger LOG = LoggerFactory.getLogger(InventoryDao.class);

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public boolean deduct(Inventory inventory) {
        String sql = "UPDATE dtf_demo_inventory SET qty = qty - ? WHERE product_id = ? AND qty >= frozen + ?";
        try {
            return jdbcTemplate.update(sql, new PreparedStatementSetter() {
                @Override
                public void setValues(PreparedStatement ps) throws SQLException {
                    ps.setInt(1, inventory.getQty());
                    ps.setInt(2, inventory.getProductId());
                    ps.setInt(3, inventory.getQty());
                }
            }) > 0;
        } catch (Exception e) {
            LOG.error("Create inventory failed.", e);
            throw new RuntimeException("Create inventory failed.");
        }
    }
}
