package com.tencent.cloud.dtf.demo.payment.dao;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementSetter;
import org.springframework.stereotype.Component;

import com.tencent.cloud.dtf.demo.payment.Payment;

@Component
public class PaymentDao {

    private static final Logger LOG = LoggerFactory.getLogger(PaymentDao.class);

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public boolean pay(Payment payment) {
        String sql = "UPDATE dtf_demo_account SET balance = balance - ? WHERE account_id = ? AND balance >= ?";
        try {
            return jdbcTemplate.update(sql, new PreparedStatementSetter() {
                @Override
                public void setValues(PreparedStatement ps) throws SQLException {
                    ps.setInt(1, payment.getBalance());
                    ps.setInt(2, payment.getAccountId());
                    ps.setInt(3, payment.getBalance());
                }
            }) > 0;
        } catch (Exception e) {
            LOG.error("Pay failed.", e);
            throw new RuntimeException("Pay failed.");
        }
    }
}