package com.tencent.cloud.dtf.demo.payment.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.tencent.cloud.dtf.demo.payment.Payment;
import com.tencent.cloud.dtf.demo.payment.dao.PaymentDao;
import com.tencent.cloud.dtf.demo.payment.proxy.PointRestTemplate;
import com.tencent.cloud.dtf.demo.payment.service.IPaymentService;

@Service
public class PaymentService implements IPaymentService {

    @Autowired
    private PaymentDao paymentDao;

    @Autowired
    private PointRestTemplate pointRestTemplate;

    @Transactional
    @Override
    public boolean pay(Payment payment) {
        if (paymentDao.pay(payment)) {
            // 加积分
            if (pointRestTemplate.point(payment)) {
                return true;
            }
        }
        throw new RuntimeException("Pay failed.");
    }
}
