package com.tencent.cloud.dtf.demo.point.dao;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementSetter;
import org.springframework.stereotype.Component;

import com.tencent.cloud.dtf.demo.point.Point;

@Component
public class PointDao {

    private static final Logger LOG = LoggerFactory.getLogger(PointDao.class);

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public boolean point(Point point) {
        String sql = "UPDATE dtf_demo_point SET point = point + ? WHERE account_id = ?";
        try {
            return jdbcTemplate.update(sql, new PreparedStatementSetter() {
                @Override
                public void setValues(PreparedStatement ps) throws SQLException {
                    ps.setInt(1, point.getPoint());
                    ps.setInt(2, point.getAccountId());
                }
            }) > 0;
        } catch (Exception e) {
            LOG.error("Record point failed.", e);
            throw new RuntimeException("Record point failed.");
        }
    }
}
