package com.tencent.cloud.dtf.demo.order.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.tencent.cloud.dtf.demo.order.Order;
import com.tencent.cloud.dtf.demo.order.dao.OrderDao;
import com.tencent.cloud.dtf.demo.order.service.IOrderService;

@Service
public class OrderService implements IOrderService {

    @Autowired
    private OrderDao orderDao;

    @Transactional
    @Override
    public boolean order(Long txId, Long branchId, Order order) {
        int orderId = orderDao.createOrder(order);
        if (orderDao.createOrderTmp(txId, branchId, orderId)) {
            return true;
        } else {
            throw new RuntimeException("Create order failed.");
        }
    }

    @Transactional
    @Override
    public boolean confirmOrder(Long txId, Long branchId, Order order) {
        if (orderDao.queryOrderTmp(txId, branchId)) {
            if (orderDao.confirmOrder(txId, branchId) && orderDao.deleteOrderTmp(txId, branchId)) {
                return true;
            }
            // 使用异常对事务进行回滚
            throw new RuntimeException("Confirm order failed.");
        } else {
            // 幂等
            return true;
        }
    }

    @Transactional
    @Override
    public boolean cancelOrder(Long txId, Long branchId, Order order) {
        if (orderDao.queryOrderTmp(txId, branchId)) {
            if (orderDao.cancelOrder(txId, branchId) && orderDao.deleteOrderTmp(txId, branchId)) {
                return true;
            }
            // 使用异常对事务进行回滚
            throw new RuntimeException("Cancel order failed.");
        } else {
            // 幂等
            return true;
        }
    }
}
