package com.tencent.cloud.dtf.demo.inventory.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.tencent.cloud.dtf.annotation.DtfTransactional;
import com.tencent.cloud.dtf.demo.inventory.Inventory;
import com.tencent.cloud.dtf.demo.inventory.service.IInventoryService;

@RestController
public class InventoryController {

    private static final Logger LOG = LoggerFactory.getLogger(InventoryController.class);

    @Autowired
    private IInventoryService inventoryService;

    @DtfTransactional
    @RequestMapping("/deduct")
    public Boolean deduct(@RequestBody Inventory inventory) {
        try {
            return inventoryService.deduct(inventory);
        } catch (Throwable t) {
            LOG.error("Failed deduct.", t);
            return false;
        }
    }
}
