package com.tencent.cloud.dtf.demo.order;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.loadbalancer.LoadBalanced;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.transaction.annotation.EnableTransactionManagement;
//import org.springframework.tsf.annotation.EnableTsf;
import org.springframework.web.client.RestTemplate;

import com.tencent.cloud.dtf.annotation.EnableDtf;

@SpringBootApplication
@EnableDtf
//@EnableTsf
@EnableTransactionManagement
@EnableFeignClients
public class OrderApplication {
    public static void main(String[] args) {
        SpringApplication.run(OrderApplication.class, args);
    }

    @Bean
    @LoadBalanced
    public RestTemplate restTemplate() {
        return new RestTemplate();
    }

}