package com.tencent.cloud.dtf.demo.payment.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.tencent.cloud.dtf.demo.payment.Payment;
import com.tencent.cloud.dtf.demo.payment.dao.PaymentDao;
import com.tencent.cloud.dtf.demo.payment.proxy.Point;
import com.tencent.cloud.dtf.demo.payment.proxy.PointProxy;
import com.tencent.cloud.dtf.demo.payment.service.IPaymentService;

@Service
public class PaymentService implements IPaymentService {

    @Autowired
    private PaymentDao paymentDao;

    @Autowired
    private PointProxy pointProxy;

    @Transactional
    @Override
    public boolean pay(Payment payment) {
        if (paymentDao.pay(payment)) {
            // 加积分
            Point point = new Point();
            point.setAccountId(payment.getAccountId());
            point.setPoint(payment.getBalance());
            if (pointProxy.point(point)) {
                return true;
            }
        }
        throw new RuntimeException("Pay failed.");
    }

}
