package com.tencent.cloud.dtf.demo.point;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.context.annotation.Bean;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.tsf.annotation.EnableTsf;

import com.tencent.cloud.dtf.annotation.EnableDtf;

import feign.Retryer;

@SpringBootApplication
@EnableDtf
@EnableTsf
@EnableDiscoveryClient
@EnableTransactionManagement
public class PointApplication {

    public static void main(String[] args) {
        SpringApplication.run(PointApplication.class, args);
    }

    @Bean
    public Retryer feignRetryer() {
        return Retryer.NEVER_RETRY;
    }
}
