package com.tencent.cloud.dtf.demo.point.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.tencent.cloud.dtf.demo.point.Point;
import com.tencent.cloud.dtf.demo.point.dao.PointDao;
import com.tencent.cloud.dtf.demo.point.service.IPointService;

@Service
public class PointService implements IPointService {

    @Autowired
    private PointDao pointDao;

    @Transactional
    @Override
    public boolean point(Long txId, Long branchId, Point point) {
        if (pointDao.point(point) && pointDao.createPointTmp(txId, branchId, point)) {
            return true;
        }
        throw new RuntimeException("Record point failed.");
    }

    @Transactional
    @Override
    public boolean confirmPoint(Long txId, Long branchId, Point point) {
        if (pointDao.queryPointTmp(txId, branchId, point)) {
            if (pointDao.confirmPoint(point) && pointDao.deletePointTmp(txId, branchId, point)) {
                return true;
            }
            // 使用异常对事务进行回滚
            throw new RuntimeException("Confirm point failed.");
        } else {
            return true;
        }
    }

    @Transactional
    @Override
    public boolean cancelPoint(Long txId, Long branchId, Point point) {
        if (pointDao.queryPointTmp(txId, branchId, point)) {
            if (pointDao.cancelPoint(point) && pointDao.deletePointTmp(txId, branchId, point)) {
                return true;
            }
            // 使用异常对事务进行回滚
            throw new RuntimeException("Cancel point failed.");
        } else {
            return true;
        }
    }

}
